<template>
  <div>
    <el-breadcrumb separator=">">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="#">系统管理</a>
      </el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="/base/dishes">菜品管理</a>
      </el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider></el-divider>
    <!--
      要resetFields起作用，必须配置:model和prop
    -->
    <el-form ref="queryForm" :model="queryModel" inline class="demo-form-inline">
      <el-form-item label="名称" prop="name">
        <el-input type="text" size="mini" v-model="queryModel.name"></el-input>
      </el-form-item>
      <el-form-item label="标签" prop="tag">
        <el-input type="text" size="mini" v-model="queryModel.tag"></el-input>
      </el-form-item>
      <el-form-item label="类型" prop="type">
        <el-select v-model="queryModel.type" size="mini" filterable placeholder="请选择类型">
          <el-option v-for="typeClass in typeClassResult" :key="typeClass.value" :label="typeClass.name" :value="typeClass.id"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="供应区域" prop="areaId">
        <el-select-tree size="mini" :props="props" :options="queryAreaResult" v-model="queryModel.areaId" height="200"></el-select-tree>&nbsp;
        <el-checkbox v-if="blChild" v-model="queryModel.areaChild">包含下级</el-checkbox>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" size="mini" icon="ios-search" @click="changePage(1)" :loading="loading">查询</el-button>&nbsp;
        <el-button type="info" size="mini" style="margin-left: 8px" @click="handleReset('queryForm')">重置</el-button>&nbsp;
      </el-form-item>
    </el-form>
    <el-divider></el-divider>
    <el-row class="button-group">
      <el-button type="primary" size="small" plain icon="el-icon-circle-plus" @click="handleAdd">新增</el-button>
      <el-button type="primary" size="small" plain icon="el-icon-circle-plus" :disabled="multipleSelection.length == 0" @click="handleBatchDelete">删除选中项</el-button>
    </el-row>
    <el-table :data="tableData" style="min-height: 400px" v-loading="loading" stripe @sort-change="sortChange" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column prop="typeName" label="类型" width="180"></el-table-column>
      <el-table-column prop="areaName" label="供应区域" width="180"></el-table-column>
      <el-table-column prop="name" label="名称" width="180"></el-table-column>
      <el-table-column prop="url" label="图片" width="180">
        <template slot-scope="{row}">
          <el-image v-if="row.url != null" style="width: 100px; height: 100px" fit="contain" :src="row.url"></el-image>
          <img v-else src="../../assets/noPicture.png" height="100" width="100"/>
        </template>
      </el-table-column>
      <el-table-column prop="price" label="售价" width="180"></el-table-column>
      <el-table-column prop="tag" label="标签" width="180"></el-table-column>
      <el-table-column label="操作">
        <template slot-scope="{ row }">
          <el-button size="mini" type="info" @click="handleIngredient(row)">食材</el-button>
          <el-button size="mini" type="warning" @click="handleEdit(row)">编辑</el-button>
          <el-button size="mini" type="danger" @click="handleDelete(row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      :current-page.sync="pageIndex"
      :total="totalElements"
      :page-sizes="pageSizeList"
      @current-change="changePage"
      @size-change="pageSizeChange"
      layout="total, sizes, prev, pager, next, jumper"
    ></el-pagination>
    <dishes-detail
      v-if="showModal"
      :businessKey="businessKey"
      :title="modalTitle"
      @close="onDetailModalClose"
    ></dishes-detail>
    <dishesIngredient-list
    v-if="showIngredientList"
    :businessKey="businessKey"
    :title="modalTitle"
    @close="onDetailModalClose"
    ></dishesIngredient-list>
  </div>
</template>
<script>
import Constant from "@/constant";
import DishesDetail from "./dishes-detail";
import DishesIngredientList from "./dishesIngredient-list";
import dishesApi from "@/api/base/dishes";
import NProgress from "nprogress"; // progress bar
import "nprogress/nprogress.css"; // progress bar style
import areaApi from "@/api/base/area";
import SelectTree from "@/components/SelectTree";
import dataDictionaryApi from "@/api/sys/dataDictionary";

export default {
  data() {
    var self = this;

    return {
      queryModel: {
        type: "",
        areaId: "",
        name: "",
        tag: "",
        areaChild: false,
      },
      loading: false,
      tableData: [],
      pageIndex: 1,
      pageSize: 10,
      totalPages: 0,
      totalElements: 0,
      field: "",
      direction: "",
      pageSizeList: [10, 20, 30],
      multipleSelection: [],
      showModal: false,
      showIngredientList: false,
      modalTitle: "",
      businessKey: "",
      queryAreaResult: [],
      props: {
        value: "id",
        label: "name"
      },
      blChild: false,
      typeClassResult: [],
    };
  },
  methods: {
    changePage(pageIndex) {
      var self = this;

      self.loading = true;

      self.pageIndex = pageIndex;
      var formData = new FormData();

      formData.append("pageIndex", self.pageIndex);
      formData.append("pageSize", self.pageSize);

      formData.append("type", self.queryModel.type);
      formData.append("areaId", self.queryModel.areaId);
      formData.append("name", self.queryModel.name);
      formData.append("tag", self.queryModel.tag);
      formData.append("areaChild", self.queryModel.areaChild);

      if (this.field != null) {
        formData.append("field", this.field);
      }

      if (this.direction != null) {
        formData.append("direction", this.direction);
      }

      dishesApi
        .pageList(formData)
        .then(function (response) {
          self.loading = false;

          var jsonData = response.data.data;

          self.tableData = jsonData.data;
          self.totalPages = jsonData.totalPages;
          self.totalElements = jsonData.recordsTotal;
        })
        .catch((error) => {
          self.loading = false;
          // self.$message.error(error + "");
        });
    },
    pageSizeChange(pageSize) {
      this.pageSize = pageSize;

      this.$nextTick(() => {
        this.changePage(this.pageIndex);
      });
    },
    sortChange(data) {
      this.field = data.column.field;
      this.direction = data.order;

      this.changePage(this.pageIndex);
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleReset(name) {
      this.$refs[name].resetFields();
    },
    handleAdd() {
      this.modalTitle = "新增";
      this.businessKey = "";
      this.showModal = true;
    },
    handleEdit(record) {
      this.modalTitle = "编辑";
      this.businessKey = record.id;
      this.showModal = true;
    },
    handleIngredient(record) {
      this.modalTitle = "食材";
      this.businessKey = record.id;
      this.showIngredientList = true;
    },
    handleDelete(record) {
      var self = this;

      self
        .$confirm("是否确认删除?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
        .then(() => {
          dishesApi.remove(record.id).then(function (response) {
            var jsonData = response.data;

            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: "删除成功!",
              });
            }
          });
        });
    },
    handleBatchDelete() {
      var self = this;

      var idList = this.multipleSelection.map((record) => {
        return record.id;
      });

      this.$confirm("是否确认删除选中项？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        dishesApi.batchRemove(idList).then(function (response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!",
            });
          }
        });
      });
    },
    onDetailModalClose(refreshed) {
      //保存成功后回调
      this.showModal = false;
      this.showIngredientList = false;

      if (refreshed) {
        this.changePage(this.pageIndex);
      }
    },
  },
  mounted: function () {
    this.changePage(1);

    var formData = new FormData();
    areaApi.queryList(formData).then(response=>{
      var jsonData = response.data;
      this.queryAreaResult = jsonData;
    });

    dataDictionaryApi.findByCatalogName({
      catalogName: "菜品分类",
    })
    .then((response) => {
      var jsonData = response.data;
      this.typeClassResult = jsonData.data;
    });
  },
  components: {
    "dishes-detail": DishesDetail,
    "dishesIngredient-list": DishesIngredientList,
    "el-select-tree": SelectTree
  },
  watch: {
    "queryModel.areaId"(newVal,oldVal) {
      if(newVal == null || newVal == ''){
        this.blChild = false;
      }
      else{
        this.blChild = true;
      }
    }
  }
};
</script>
<style lang="scss" scoped>
.el-breadcrumb {
  margin: 10px;
  line-height: 20px;
}

.el-divider {
  margin: 5px 0;
}

.demo-form-inline {
  margin-left: 10px;
  text-align: left;
}

.button-group {
  margin-left: 10px;
  text-align: left;
}
</style>